//+------------------------------------------------------------------+
//|                                                MANATFCompare.mq4 |
//|                                                                * |
//|                                                                * |
//+------------------------------------------------------------------+
#property copyright "*"
#property link      "*"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Yellow
//---- input parameters
extern int TimeFrame=0;
extern int MAPeriod=14;
extern int MAMethod=0;
extern int MAPrice=0;

      
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  
   if(TimeFrame==0)TimeFrame=Period();
  
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   datetime daytimes[];
   static bool err;
   ArrayCopySeries(daytimes,MODE_TIME,Symbol(),TimeFrame);
      if(GetLastError()==4066){
         Comment("     "+fTimeFrameName(TimeFrame));
         err=true;
         return(0);
      }
   int limit=Bars-IndicatorCounted();
      if(err){
         err=false;
         limit=Bars;
         Comment("");
      }

	int NTFBarNum=iBarShift(NULL,TimeFrame,Time[limit-1],true);
	datetime NTFTime=iTime(NULL,TimeFrame,NTFBarNum);
	limit=iBarShift(NULL,0,NTFTime)+1;
	
	for(int i=limit-1;i>=0;i--){
           int BarNum=iBarShift(NULL,TimeFrame,Time[i],false); 
           ExtMapBuffer1[i]=iMA(NULL,TimeFrame,MAPeriod,0,MAMethod,MAPrice,BarNum);
           ExtMapBuffer2[i]=iMA(NULL,0,MAPeriod*(TimeFrame/Period()),0,MAMethod,MAPrice,i);
           
           
   }
   return(0);
  }
//+------------------------------------------------------------------+

string fTimeFrameName(int arg){

   // fTimeFrameName();

   int v;
      if(arg==0){
         v=Period();
      }
      else{
         v=arg;
      }
      switch(v){
         case 0:
            return("0");
         case 1:
            return("M1");
         case 5:
            return("M5");                  
         case 15:
            return("M15");
         case 30:
            return("M30");             
         case 60:
            return("H1");
         case 240:
            return("H4");                  
         case 1440:
            return("D1");
         case 10080:
            return("W1");          
         case 43200:
            return("MN1");
         default:
            return("Wrong TimeFrame");          
      }
}

